// PipedStreamTest.java
package com.jdojo.io;

import java.io.PipedInputStream;
import java.io.PipedOutputStream;

public class PipedStreamTest {
	public static void main(String[] args) throws Exception {
		// Create and connect piped input and output streams 
		PipedInputStream pis = new PipedInputStream();
		PipedOutputStream pos = new PipedOutputStream();
		pos.connect(pis);
		
		// Creates and starts two threads - one to produce data (write data) 
		// and one to consume data (read data)
		Runnable producer = () -> produceData(pos);
		Runnable consumer = () -> consumeData(pis);		
		new Thread(producer).start();
		new Thread(consumer).start();
	}

	public static void produceData(PipedOutputStream pos) {
		try {
			for (int i = 1; i <= 50; i++) {
				pos.write((byte) i);
				pos.flush();
				System.out.println("Writing: " + i);
				Thread.sleep(500);
			}
			pos.close();
		} 
		catch (Exception e) {
			e.printStackTrace();
		}
	}

	public static void consumeData(PipedInputStream pis) {
		try {
			int num = -1;
			while ((num = pis.read()) != -1) {
				System.out.println("Reading: " + num);
			}
			pis.close();
		} 
		catch (Exception e) {
			e.printStackTrace();
		}

	}
}
